﻿using DatabaseExtension.ConnectionString;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using DatabaseExtension;
using OracleProvider.Enums;

namespace Test
{
    
    
    /// <summary>
    ///Dies ist eine Testklasse für "ConnectionInfoTest" und soll
    ///alle ConnectionInfoTest Komponententests enthalten.
    ///</summary>
    [TestClass()]
    public class ConnectionInfoTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Ruft den Testkontext auf, der Informationen
        ///über und Funktionalität für den aktuellen Testlauf bietet, oder legt diesen fest.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Zusätzliche Testattribute
        // 
        //Sie können beim Verfassen Ihrer Tests die folgenden zusätzlichen Attribute verwenden:
        //
        //Mit ClassInitialize führen Sie Code aus, bevor Sie den ersten Test in der Klasse ausführen.
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Mit ClassCleanup führen Sie Code aus, nachdem alle Tests in einer Klasse ausgeführt wurden.
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Mit TestInitialize können Sie vor jedem einzelnen Test Code ausführen.
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Mit TestCleanup können Sie nach jedem einzelnen Test Code ausführen.
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        private class TestConClass : ConnectionInfo
        {
            public TestConClass()
                : base(DatabaseExtension.Databases.None, null)
            {
            }
            public String EnumToStringTest(Enum e)
            {
                return e.EnumToString();
            }
            public Object StringToEnumTest(Type t, String s)
            {
                return s.StringToEnum(t);
            }
        }

        internal virtual ConnectionInfo_Accessor CreateConnectionInfo_Accessor()
        {
            // TODO: Geeignete konkrete Klasse instanziieren
            ConnectionInfo_Accessor target = null;
            return target;
        }
        #region Enum To String
        /// <summary>
        ///Ein Test für "EnumToString"
        ///</summary>
        [TestMethod()]
        [DeploymentItem("DatabaseExtension.dll")]
        public void EnumToStringTestSimple()
        {
            TestConClass target = new TestConClass(); // TODO: Passenden Wert initialisieren
            OracleProvider.Enums.OracleDBAPrivilege e = OracleProvider.Enums.OracleDBAPrivilege.SYSDBA; // TODO: Passenden Wert initialisieren
            string expected = "SYSDBA"; // TODO: Passenden Wert initialisieren
            string actual;
            actual = target.EnumToStringTest(e);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///Ein Test für "EnumToString"
        ///</summary>
        [TestMethod()]
        [DeploymentItem("DatabaseExtension.dll")]
        public void EnumToStringTestComplex()
        {
            TestConClass target = new TestConClass(); // TODO: Passenden Wert initialisieren
            DatabaseExtension.Enums.Sql.SqlTypeSystemVersion e = DatabaseExtension.Enums.Sql.SqlTypeSystemVersion.SQL_Server_2008;
            string expected = "SQL Server 2008"; // TODO: Passenden Wert initialisieren
            string actual;
            actual = target.EnumToStringTest(e);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///Ein Test für "EnumToString"
        ///</summary>
        [TestMethod()]
        [DeploymentItem("DatabaseExtension.dll")]
        public void EnumToStringTestNone()
        {
            TestConClass target = new TestConClass(); // TODO: Passenden Wert initialisieren
            DatabaseExtension.Enums.Sql.SqlTypeSystemVersion e = DatabaseExtension.Enums.Sql.SqlTypeSystemVersion.None;
            string expected = null; // TODO: Passenden Wert initialisieren
            string actual;
            actual = target.EnumToStringTest(e);
            Assert.AreEqual(expected, actual);
        }
        #endregion
        #region String To Enum
        /// <summary>
        ///Ein Test für "StringToEnum"
        ///</summary>
        [TestMethod()]
        [DeploymentItem("DatabaseExtension.dll")]
        public void StringToEnumTestComplex()
        {
            TestConClass target = new TestConClass(); // TODO: Passenden Wert initialisieren
            String data  = "SQL Server 2008";
            var expected = DatabaseExtension.Enums.Sql.SqlTypeSystemVersion.SQL_Server_2008;
            var actual =  DatabaseExtension.Enums.Sql.SqlTypeSystemVersion.None;
            actual = (DatabaseExtension.Enums.Sql.SqlTypeSystemVersion)target.StringToEnumTest(typeof(DatabaseExtension.Enums.Sql.SqlTypeSystemVersion), data);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///Test Simple Conversion to Enum
        ///</summary>
        [TestMethod()]
        [DeploymentItem("DatabaseExtension.dll")]
        public void StringToEnumTestSimple()
        {
            TestConClass target = new TestConClass(); // TODO: Passenden Wert initialisieren
            String data = "SYSDBA";
            var expected = OracleDBAPrivilege.SYSDBA;
            var actual = OracleDBAPrivilege.None;
            actual = (OracleDBAPrivilege)target.StringToEnumTest(typeof(OracleDBAPrivilege), data);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///Test Simple Conversion to Enum
        ///</summary>
        [TestMethod()]
        [DeploymentItem("DatabaseExtension.dll")]
        public void StringToEnumTestNone()
        {
            TestConClass target = new TestConClass(); // TODO: Passenden Wert initialisieren
            var expected = OracleDBAPrivilege.None;
            var actual = OracleDBAPrivilege.None;
            actual = (OracleDBAPrivilege)target.StringToEnumTest(typeof(OracleDBAPrivilege), null);
            Assert.AreEqual(expected, actual);
        }
        #endregion
    }
}
