﻿using DatabaseExtension.QueryBuilder;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Data.Common.QueryBuilder;

namespace Test
{
    
    
    /// <summary>
    ///Dies ist eine Testklasse für "QSelectTest" und soll
    ///alle QSelectTest Komponententests enthalten.
    ///</summary>
    [TestClass()]
    public class QSelectTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Ruft den Testkontext auf, der Informationen
        ///über und Funktionalität für den aktuellen Testlauf bietet, oder legt diesen fest.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Zusätzliche Testattribute
        // 
        //Sie können beim Verfassen Ihrer Tests die folgenden zusätzlichen Attribute verwenden:
        //
        //Mit ClassInitialize führen Sie Code aus, bevor Sie den ersten Test in der Klasse ausführen.
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Mit ClassCleanup führen Sie Code aus, nachdem alle Tests in einer Klasse ausgeführt wurden.
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Mit TestInitialize können Sie vor jedem einzelnen Test Code ausführen.
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Mit TestCleanup können Sie nach jedem einzelnen Test Code ausführen.
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///Ein Test für "QSelect-Konstruktor"
        ///</summary>
        [TestMethod()]
        public void QSelectConstructorTest()
        {
            string Table = string.Empty; // TODO: Passenden Wert initialisieren
            DbQuerySelect target = 
                new DbQuerySelect("test.dbo.test a with (nolock)").AddColumn("a.my_id").
                Where.QueryCompare("a.my_id>10").Or.QueryCompare("a.name like '%kidding me?%'").EndWhere.
                GroupBy.GroupBy("a.my_id, a.name").Having("LEN(a.name)>10").EndGroupBy.
                OrderBy.AddColumn(DbQueryOrderBy.OrderBy.DESC, "name").EndOrderBy;
            Console.Write(target);
        }

        /// <summary>
        ///Ein Test für "QSelect-Konstruktor"
        ///</summary>
        [TestMethod()]
        public void QSelectConstructorTestJoin()
        {
            string Table = string.Empty; // TODO: Passenden Wert initialisieren
            DbQuerySelect target =
                new DbQuerySelect("test.dbo.test a with (nolock)").AddColumn("a.my_id", "b.id").
                Where.QueryCompare("a.my_id>10").Or.QueryCompare("a.name like '%kidding me?%'").EndWhere.
                GroupBy.GroupBy("a.my_id, a.name").Having("LEN(a.name)>10").EndGroupBy.
                OrderBy.AddColumn(DbQueryOrderBy.OrderBy.DESC, "name").EndOrderBy.
                Join("test.dbo.test2 b with (nolock)", QJoin.JoinType.FULL_OUTER_JOIN).
                    On("a.id = b.id").And.On("a.id <= 10").Or.On("b.id>100").EndJoin;
            Console.Write(target);
        }
    }
}
